'''Sequence that will be shown to a user, sequence of blocks'''
# this class is made entirely for the screen with width = 1000 and height = 800

#pygame is the library for drawing
#time is the library for time
import time
import pygame

#importing the predefined class with block
from Block import Block

class Sequence:
    '''Sequence class defines the main functions that will be used by a sequence'''

    # constructor to initiate the sequence
    # i -- the number of sequence that the researcher is using (1-4)
    def __init__(self, i):
        self.i = i
        self.sequence = []

    def create_sequence(self):
        '''this method creates one of four standard sequences depending on the given parameter i'''
        if self.i == 1:
            #creating Blocks and locating them on the screen
            pressed = False
            block1 = Block(400, 120, 50, pressed, 1)
            block2 = Block(100, 100, 50, pressed, 2)
            block3 = Block(600, 150, 50, pressed, 3)
            block4 = Block(125, 300, 50, pressed, 4)
            block5 = Block(425, 315, 50, pressed, 5)
            block6 = Block(625, 335, 50, pressed, 6)
            block7 = Block(60, 450, 50, pressed, 7)
            block8 = Block(450, 580, 50, pressed, 8)
            block9 = Block(550, 550, 50, pressed, 9)

            #putting the created blocks into a list for keeping the sequence
            self.sequence = [block1, block2, block3, block4, block5, block6, block7, block8, block9]
        elif self.i == 2:
            #creating Blocks and locating them on the screen
            pressed = False
            block1 = Block(100, 550, 50, pressed, 1)
            block2 = Block(200, 570, 50, pressed, 2)
            block3 = Block(600, 700, 50, pressed, 3)
            block4 = Block(300, 350, 50, pressed, 4)
            block5 = Block(350, 450, 50, pressed, 5)
            block6 = Block(700, 600, 50, pressed, 6)
            block7 = Block(400, 100, 50, pressed, 7)
            block8 = Block(500, 70, 50, pressed, 8)
            block9 = Block(800, 200, 50, pressed, 9)

            #putting the created blocks into a list for keeping the sequence
            self.sequence = [block1, block2, block3, block4, block5, block6, block7, block8, block9]
        elif self.i == 3:
            #creating Blocks and locating them on the screen
            pressed = False
            block1 = Block(400, 120, 50, pressed, 1)
            block2 = Block(100, 100, 50, pressed, 2)
            block3 = Block(600, 150, 50, pressed, 3)
            block4 = Block(125, 300, 50, pressed, 4)
            block5 = Block(425, 315, 50, pressed, 5)
            block6 = Block(625, 335, 50, pressed, 6)
            block7 = Block(60, 450, 50, pressed, 7)
            block8 = Block(450, 580, 50, pressed, 8)
            block9 = Block(550, 550, 50, pressed, 9)

            #putting the created blocks into a list for keeping the sequence
            self.sequence = [block1, block2, block3, block4, block5, block6, block7, block8, block9]
        elif self.i == 4:
            #creating Blocks and locating them on the screen
            pressed = False
            block1 = Block(400, 120, 50, pressed, 1)
            block2 = Block(100, 100, 50, pressed, 2)
            block3 = Block(600, 150, 50, pressed, 3)
            block4 = Block(125, 300, 50, pressed, 4)
            block5 = Block(425, 315, 50, pressed, 5)
            block6 = Block(625, 335, 50, pressed, 6)
            block7 = Block(60, 450, 50, pressed, 7)
            block8 = Block(450, 580, 50, pressed, 8)
            block9 = Block(550, 550, 50, pressed, 9)

            #putting the created blocks into a list for keeping the sequence
            self.sequence = [block1, block2, block3, block4, block5, block6, block7, block8, block9]
        else:
            print("Researcher does not know how to use this program. Error.")

    def draw_sequence_human(self, screen, event):
        '''this method draws the sequence made by a user'''
        for block in self.sequence:
            block.clicked(screen, event)

    def draw_sequence_comp(self, screen):
        '''this method draws the sequence which user will need to repeat'''

        #first showing user the blocks themselves
        for block in self.sequence:
            block.draw_block(screen)
            pygame.display.update()

        #waiting 2 seconds to allow user see all the blocks
        time.sleep(2)

        #showing user the pattern by changing the color of blocks from black to grey
        for block in self.sequence:
            block.draw_computer(screen)
            pygame.display.update()
            time.sleep(0.5)

    # user_seq -- the sequence which user entered
    def compare_sequences(self, user_seq):
        '''this method compares sequences and returns the number of errors user made'''
        #k -- counter for errors that user made while repeating the pattern
        #if this metod returns -1, we know that there is an error in input
        k=-1

        #we can compare sequences only if they are of the same length
        if len(user_seq) == len(self.sequence):

            #the loop comparing two sequences by comparing each pair of elements
            for i in range(len(self.sequence)):

                #if elements on the same position in two sequences are not equal,
                #then the counter is getting +1
                if user_seq[i].ID == self.sequence[i].ID:
                    k = k + 1
        return k

#this class will be tested, thus, we need this main method
#as it sets the environment where we are going to test
def main():
    '''This is MAAAAIN'''
    #defining the screen parameters
    pygame.init()
    width = 1000
    height = 800
    pygame.display.set_mode((width, height))
    screen = pygame.display.get_surface()
    screen.fill((255,255,255))

    #creating the test object
    test_sequence = Sequence(2)
    test_sequence.create_sequence()
    test_sequence.draw_sequence_comp(screen)
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
            test_sequence.draw_sequence_human(screen, event)
            pygame.display.update()

#class functions testing
if __name__ == '__main__':
    main()
